
%% Connect
c = rConnect('http://carre.kmi.open.ac.uk/ws', 'rugodzinski', 'qwe123');

%% Get nodes by atributes
% http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_evidence_observable
% http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_observable

[ n1 ] = rGetNodesByAtribue( c, 'r:has_risk_evidence_observable' );
[ n2 ] = rGetNodesByAtribue( c, 'r:has_risk_element_observable' );

n = [n2;n1];
clear n1 n2
n = n(~cellfun(@isempty,strfind(n, 'node')));
n = unique(n);

%% Get observables attached to risk evidence and risk elements
n_obs = {};

for k = 1:length(n)
    n1 = rGetNodeAtribute( c, n{k} , 'r:has_risk_evidence_observable');
    n2 = rGetNodeAtribute( c, n{k} , 'r:has_risk_element_observable');
    n_obs = [n_obs; n1; n2];
end

%% Couting

n_uniq = unique(n_obs);
count = zeros(length(n_uniq),1);

for k = 1:length(n_uniq);
    count(k) = sum(strcmp(n_obs, n_uniq(k)));
end

count = num2cell(count);

n_uniq = [n_uniq,count];
n_uniq = sortrows(n_uniq,-2);

%% Get names of observables

n_un_named = [n_uniq, cell(length(n_uniq),1)];

for k = 1:length(n_uniq)
    n_un_named(k,3) = rGetNodeAtribute( c, n_un_named{k,1} , 'r:has_observable_name');
end
