function varargout = rGUI(varargin)
% RGUI MATLAB code for rGUI.fig
%      RGUI, by itself, creates a new RGUI or raises the existing
%      singleton*.
%
%      H = RGUI returns the handle to a new RGUI or the handle to
%      the existing singleton*.
%
%      RGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RGUI.M with the given input arguments.
%
%      RGUI('Property','Value',...) creates a new RGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before rGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to rGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help rGUI

% Last Modified by GUIDE v2.5 07-Apr-2015 09:34:50

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @rGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @rGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before rGUI is made visible.
function rGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to rGUI (see VARARGIN)

%inicjalizacja zmiennych mozliwych do rysowania
handles.AvaiiblePlots = ...
    { 'Steps' 's:has_steps' 'Nr of steps'
      'Floors' 's:has_floors' 'Nr of floors'
      'Distance' 's:has_distance' 'kilometers'
      'Activity calories' 's:has_activity_calories' 'calories'};
set(handles.lbPlots, 'String', handles.AvaiiblePlots(:,1));
handles.Connected = false;

% Choose default command line output for rGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes rGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = rGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in lbPlots.
function lbPlots_Callback(hObject, eventdata, handles)
% hObject    handle to lbPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns lbPlots contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lbPlots
if(handles.Connected)
    Val = get(hObject,'Value');
    Name = handles.AvaiiblePlots{Val,1};
    Query = handles.AvaiiblePlots{Val,2};
    Unit = handles.AvaiiblePlots{Val,3};
    [d,m] = rGetMeasurement( handles.Connection, Query);
    [d,m] = rCreateDailyMeasurement(d,m);
    mPlot(d,m,Name,Unit);
end

function mPlot(d,m,t,l)

plot(d,m);title(t);ylabel(l);
l = ylim;
l(1) = 0;
ylim(l);
grid;

% --- Executes during object creation, after setting all properties.
function lbPlots_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lbPlots (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edUser_Callback(hObject, eventdata, handles)
% hObject    handle to edUser (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edUser as text
%        str2double(get(hObject,'String')) returns contents of edUser as a double


% --- Executes during object creation, after setting all properties.
function edUser_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edUser (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edPass_Callback(hObject, eventdata, handles)
% hObject    handle to edPass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edPass as text
%        str2double(get(hObject,'String')) returns contents of edPass as a double


% --- Executes during object creation, after setting all properties.
function edPass_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edPass (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pbConn.
function pbConn_Callback(hObject, eventdata, handles)
% hObject    handle to pbConn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[Password, Username] = passwordEntryDialog('EnterUserName', true);
try
    handles.Connection = rConnect('http://carre.kmi.open.ac.uk/ws', Username, Password);
    handles.Connected = true;
    UserData = rUserdata(handles.Connection);
    NewString = { sprintf('Hello %s!', UserData.username)
                  sprintf('Email: %s', UserData.email) };
    set(handles.eStatus, 'String', NewString);       
    guidata(hObject, handles);
catch
    errordlg('Connection error!');
end



function eStatus_Callback(hObject, eventdata, handles)
% hObject    handle to eStatus (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of eStatus as text
%        str2double(get(hObject,'String')) returns contents of eStatus as a double


% --- Executes during object creation, after setting all properties.
function eStatus_CreateFcn(hObject, eventdata, handles)
% hObject    handle to eStatus (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
