function [ d, m ] = rGetMeasurement( con, atr)
%RGETNODESBYTYPE Summary of this function goes here
%   Detailed explanation goes here

carreSensors = 'http://carre.kmi.open.ac.uk/ontology/sensors.owl#';
carreRisk    = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#';

if     strcmp(atr(1:2), 's:')
    atr = [carreSensors atr(3:end)];
elseif strcmp(atr(1:2), 'r:')
    atr = [carreRisk    atr(3:end)];
end

query = ['SELECT ?date ?val WHERE { ?n <' atr '> ?v . ?v <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_value> ?val .  ?n <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_date> ?v2 . ?v2 <http://carre.kmi.open.ac.uk/ontology/sensors.owl#has_value> ?date } ORDER BY ?date'];

[ data ] = rQuery( con, query );

for k = 1:length(data)
    d(k) = datetime(data{k}.date.value,'InputFormat','uuuu-MM-dd''T''HH:mmXXX','TimeZone','UTC');
    if strcmp(data{k}.val.value, 'NAN')
        m(k) = NaN;
    else
        m(k) = str2num(data{k}.val.value);
    end
end

d = d';
m = m';

end