function [ obsv ] = rGetObservables( con )
%RGETOBSER Summary of this function goes here
%   Detailed explanation goes here

%some constants
name1 = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#observable_name';
name2 = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_observable_name';
unit = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#observable_unit';
datatype = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#observable_datatype';
type = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#observable_type';
id = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_identifier';


% getting observables nodes from server
[ nodes ] = rGetNodesByType( con, 'r:observable' );
% we are interested in nodes that are named 'node'
nodes = nodes(~cellfun(@isempty,strfind(nodes, 'node')));

%query each observables for atributes
obsv = struct([]);
h = waitbar(0,'Wait');
for k = 1:length(nodes)
    waitbar(k/length(nodes), h, sprintf('Wait %d/%d', k, length(nodes)));
    [ atr ] = rGetNodeAtributes( con, nodes{k} );
    if ~isempty(atr)
        obsv(end+1).plainTextAtributes = atr;
        obsv(end).node = nodes{k};
        %getting name
        ind = find(strcmp(atr(:,1), name1), 1);
        if ~isempty(ind)
            obsv(end).name = atr{ind,2};
        else
            ind = find(strcmp(atr(:,1), name2), 1);
            if ~isempty(ind)
                obsv(end).name = atr{ind,2};
            end
        end
        %getting unit
        ind = find(strcmp(atr(:,1), unit), 1);
        if ~isempty(ind)
            obsv(end).unit = atr{ind,2};
        end
        %getting datatype
        ind = find(strcmp(atr(:,1), datatype), 1);
        if ~isempty(ind)
            obsv(end).datatype = atr{ind,2};
        end
        %getting type
        ind = find(strcmp(atr(:,1), type), 1);
        if ~isempty(ind)
            S = atr{ind,2};
            from = strfind(S, '#');
            obsv(end).type = S(from+1:end);
        end
        %getting id
        ind = find(strcmp(atr(:,1), id));
        if ~isempty(ind)
            obsv(end).id = atr(ind,2);
        end
        %check for name of observable
        if isempty(obsv(end).name)
            obsv(end) = [];
            continue;
        end
    end
end
close(h);
%sorting
[~, ind]=sort({obsv.name});
obsv = obsv(ind);
%getting unique observables names
% [~, ind]=unique({obsv.name});
% obsv = obsv(ind);

end

