function [ riskEl ] = rGetRiskElements( con )
%RGETOBSER Summary of this function goes here
%   Detailed explanation goes here

%some constants
id = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_identifier';
name = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#risk_element_name';
hasObsv = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_observable';
modifiable = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_modifiable_status';
condition = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#has_risk_element_condition';
type = 'http://carre.kmi.open.ac.uk/ontology/risk.owl#risk_element_type';


% getting observables nodes from server
[ nodes ] = rGetNodesByType( con, 'r:risk_element' );
% we are interested in nodes that are named 'node'
nodes = nodes(~cellfun(@isempty,strfind(nodes, 'node')));


%query each observables for atributes
riskEl = struct([]);
h = waitbar(0,'Wait');
for k = 1:length(nodes)
    waitbar(k/length(nodes), h, sprintf('Wait %d/%d', k, length(nodes)));
    [ atr ] = rGetNodeAtributes( con, nodes{k} );
    if ~isempty(atr)
        riskEl(end+1).plainTextAtributes = atr;
        riskEl(end).node = nodes{k};
        %getting name
        ind = find(strcmp(atr(:,1), name), 1);
        if ~isempty(ind)
            riskEl(end).name = atr{ind,2};
        end
        %getting OBSV
        ind = find(strcmp(atr(:,1), hasObsv));
        if ~isempty(ind)
            riskEl(end).obsv = atr(ind,2);
        end
        %getting modifiable
        ind = find(strcmp(atr(:,1), modifiable), 1);
        if ~isempty(ind)
            riskEl(end).modifiable = str2double(atr{ind,2});
            if isnan(riskEl(end).modifiable)
                riskEl(end).modifiable = 0;
            end
        end
        %getting type
        ind = find(strcmp(atr(:,1), type), 1);
        if ~isempty(ind)
            S = atr{ind,2};
            from = strfind(S, '#');
            riskEl(end).type = S(from+1:end);
        end
        %getting id
        ind = find(strcmp(atr(:,1), id));
        if ~isempty(ind)
            riskEl(end).id = atr(ind,2);
        end
        %getting condition
        ind = find(strcmp(atr(:,1), condition), 1);
        if ~isempty(ind)
            riskEl(end).condition = atr{ind,2};
        end        
        %check for name of risk element
        if isempty(riskEl(end).name)
            riskEl(end) = [];
            continue;
        end
    end
end
close(h);
%sorting
[~, ind]=sort({riskEl.name});
riskEl = riskEl(ind);

end

