function [ output ] = s_get( conn, query, format)
%S_GET Summary Query the database.
%   format - 'dom', 'text', 'cell'

if(nargin < 3)
    format = 'text';
end

url_head = strcat(conn.endpoint,'?query=');
url_query = urlencode(query);

url = strcat(url_head, url_query);

switch format
    case 'cell-all'
        output = parseXML(url);
    case 'dom'
        output = xmlread(url);
    case 'text'
        output = urlread(url);
    case 'cell'
        output = parseSPARQL ( xmlread(url) );
    otherwise
        error('Wrong output format');
end

end

