function [ terms ] = rGetTerms( con )

% getting observables nodes from server
[ nodes ] = rGetNodesByType( con, 'http://www.w3.org/2004/02/skos/core#Concept' );

%query each observables for atributes
terms = struct([]);
h = waitbar(0,'Wait');
for k = 1:length(nodes)
    waitbar(k/length(nodes), h, sprintf('Wait %d/%d', k, length(nodes)));
    [ atr ] = rGetNodeAtributes( con, nodes{k} );
    if ~isempty(atr)
        terms(end+1).plainTextAtributes = atr;
        terms(end).node = nodes{k};
        
        %getting label
        ind = find(strcmp(atr(:,1), 'http://www.w3.org/2000/01/rdf-schema#label'), 1);
        if ~isempty(ind)
            terms(end).label = atr{ind,2};
        end
        
    end
end
close(h);
%sorting
[~, ind]=sort({terms.label});
terms = terms(ind);